unit AXScriptHelp;

{
AXScriptHelp has some misc functions and constants that make using AXScript
a little easier.
}

interface

uses AXScript, Windows, SysUtils, ComObj, ActiveX;

const
  //MS Script Engine IDs
  CLSID_VBScript: TGUID = '{B54F3741-5B07-11CF-A4B0-00AA004A55E8}';
  CLSID_JScript: TGUID =  '{F414C260-6AC0-11CF-B6D1-00AA00BBBB58}';


procedure CreateScriptEngine(const clsid:TGUID; var Script:IActiveScript; var ScriptParse:IActiveScriptParse; const Site:IActiveScriptSite);

//These next two really belong in Windows.pas.  But since they aren't, I included them here.
function MakeLCID(lgid:WORD; srtid:WORD):DWORD; //Make Locale ID
function MakeLANGID(p:WORD; s:WORD):WORD; //Make Language ID

implementation


procedure CreateScriptEngine(const clsid:TGUID; var Script:IActiveScript; var ScriptParse:IActiveScriptParse; const Site:IActiveScriptSite);
begin
  pointer(Script) := nil; pointer(ScriptParse) := nil;
  if not Assigned(Site) then
    raise Exception.Create('A script site is required to create a scripting engine');
  OleCheck(CoCreateInstance( clsid, nil, ClsCtx_InProc_Server, IID_IActiveScript, Script ));
  Script.QueryInterface(IID_IActiveScriptParse, ScriptParse);
  Script.SetScriptSite(Site);
end;


// #define MAKELCID(lgid, srtid)  ((DWORD)((((DWORD)((WORD  )(srtid))) << 16) | ((DWORD)((WORD  )(lgid)))))
function MakeLCID(lgid:WORD; srtid:WORD):DWORD;
var
  dwlgid, dwsrtid:DWORD;
begin
  dwlgid:=lgid;
  dwsrtid:=srtid;

  Result:=(dwsrtid shl 16) or (dwlgid);
end;

// #define MAKELANGID(p, s) ((((WORD) (s)) << 10) | (WORD) (p))
function MakeLANGID(p:WORD; s:WORD):WORD;
begin
  Result:=(s shl 10) or (p);
end;

end.
